
/* Common Definitions */

#ifndef DEFS_H
#define DEFS_H	1

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <getopt.h>

/* data types */

#define errtyp		float
#define byte		unsigned char
#define word 		unsigned int
#define ind 		word*
#define state		int

/* data lengths */

#define INTLEN		sizeof(int)
#define ERRLEN		sizeof(int)
#define WORDLEN		sizeof(unsigned int)
#define INDLEN		sizeof(ind)
#define FLOATLEN	sizeof(float)
#define PNTLEN		sizeof(void*)

/* maximum values */

#define MAXERROR	0x7fffffff
#define MAXRANDOM	0x7fffffff

/* macros */

#define bitoffs(n)	((n) & 31)
#define wordoffs(n)	((n) >> 5)
#define getbit(x,i) 	((x[wordoffs(i)]>>bitoffs(i))&1)
#define min(x,y)	((x)<(y) ? (x) : (y))
#define max(x,y)	((x)>(y) ? (x) : (y))
#define getrand()	random()
#define seedrand(s)	srandom(s)
#define gettime()	time(0)

/* flags */

#define AUTO		(-1)
#define FAUTO		(-65536.0*65536.0)
#define NOENTRY		(-1)
#define UNDEF		(-1)

/* procedures */

word getbits(ind x,int i,int n);
void putbits(word w,ind x,int i,int n);
int duallog(int n);
int getint(char *s,int min,int max);
int getfloat(float *y,char *s,float min,float max);
int rounddec(int x);

#endif

