
/* Implementaion of the Encode/Decoder-Problem */

#include "defs.h"
#include "ind.h"
#include "stdnet.h"

/* Parameter Handling */

#define DEFNIN		AUTO
#define DEFNHID		AUTO

#define MAXIN		0x7fff
#define MAXHID		15

char *StdOptStr() {return  "N:M:\0";} 

char *StdUsage() {return  
  "Network (N-M-N-ENC/DEC) Parameters:\n"
  "-N <no. of inputs/outputs>:       4\n" 
  "-M <no. of hidden units>:         auto (>= ld M)\n\0";} 

/* set default values */

int Nin	  = DEFNIN;	/* no. of inputs */
int Nhid  = DEFNHID;	/* no. of hidden units */

int handleStdOpt(char opt,char* arg)
{
  switch(opt)
  {
    case 'N': return (Nin	=getint(arg,1,MAXIN))<0;
    case 'M': return (Nhid	=getint(arg,1,MAXHID))<0;
    default: return 1;
  };
}

int initStd()
{
  if(Nin==AUTO) Nin=4;
  Nout=Nin;
  if(Nhid==AUTO) Nhid=duallog(Nin);
  if(Nhid<duallog(Nin)) return 1;
  Ntrain=Nin;
  sprintf(StdName,"%d-%d-%d ENC/DEC",Nin,Nhid,Nout);
  return 0;
}

void initTrain()
{
  int p,i;
  
  for(p=0;p<Ntrain;p++)
    for(i=0;i<Nin;i++) 
      TrainIn[p][i]=TrainOut[p][i]= p==i ? 1.0 : 0.0;
}
