
/* Declarations of individual-specific functions */

#ifndef IND_H
#define IND_H	1

#include "defs.h"

int ptrain;

/* Genetic */

char *IndOptStr();
char *IndUsage();
char IndParamStr[256]; 

int CrBits;	/* length of one chromosome in bits */
int CrBytes;	/* length of one chromosome in bytes */
int CrWords;	/* length of one chromosome in words */

int OffsTrain;		/* Offset of error estimate */
int NoTrain;		/* No. of patterns of err. estim. */
float Estimate;		/* initial information ratio */

int handleIndOpt(char opt,char* arg);
int initInd();

int GenCalcs;

errtyp calcerr(ind x);
void printind(ind x);

/* Backpropagation */

char *NetOptStr();
char *NetUsage();
char NetParamStr[256]; 

int Nin;	/* no. of inputs */
int Nhid; 	/* no. of hidden units */
int Nout; 	/* no. of outputs */

float **TrainIn;	/* Training Set Input */
float **TrainOut;	/* Training Set Output */
int Ntrain;		/* no. of patterns */

int Nback;	/* no. of backprop. steps for combined moethod */

int BackCalcs;

int handleNetOpt(char opt,char* arg);
int initNet();

#endif
